=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2007-10-28 23:47:31 +0000
+++ bzrlib/repository.py	2007-10-29 23:55:41 +0000
@@ -840,10 +840,13 @@
         extent possible considering file system caching etc).
         """
 
-    def fetch(self, source, revision_id=None, pb=None):
+    def fetch(self, source, revision_id=None, pb=None, find_ghosts=False):
         """Fetch the content required to construct revision_id from source.
 
         If revision_id is None all content is copied.
+        :param find_ghosts: Find and copy revisions in the source that are
+            ghosts in the target (and not reachable directly by walking out to
+            the first-present revision in target from revision_id).
         """
         # fast path same-url fetch operations
         if self.has_same_location(source):

=== modified file 'bzrlib/tests/interrepository_implementations/test_interrepository.py'
--- bzrlib/tests/interrepository_implementations/test_interrepository.py	2007-10-17 09:39:41 +0000
+++ bzrlib/tests/interrepository_implementations/test_interrepository.py	2007-10-29 23:55:41 +0000
@@ -337,7 +337,7 @@
         repo = repository.Repository.open('missing_ghost')
         rev = repo.get_revision('with_ghost')
         from_repo = repository.Repository.open('with_ghost_rev')
-        repo.fetch(from_repo)
+        repo.fetch(from_repo, find_ghosts=True)
         # rev must not be corrupt now
         rev = repo.get_revision('with_ghost')
         self.assertEqual([None, 'ghost', 'with_ghost'], repo.get_ancestry('with_ghost'))

